## hedgewars 0.9.21

=== debian/changelog ===
hedgewars (0.9.21-3) unstable; urgency=medium

  * Fix bad ghc find module cmake script.
  * Fix arm* build failures.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 29 Dec 2014 09:58:48 +0100

hedgewars (0.9.21-2) experimental; urgency=medium

  * Enable experimental BUILD_ENGINE_C.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Sun, 28 Dec 2014 21:49:51 +0100

hedgewars (0.9.21-1) unstable; urgency=medium

  * New upstream release (Closes: #760776).
    + New type of randomly generated maps: Perlin Maps.
    + Old Random generated maps are more diverse now.
    + Slider for adjusting land generation detail.
    + Highlander gamemode can now be used with custom weapon schemes
      (1-8=How probable to get this weapon. 9=All hogs get it)
    + New gameplay mode "Construction Mode"
    + New gameplay mode "TechRacer"
    + New game play mode "DiagonalMaze" (generates a simple diagonal maze)
    + Add 7 target practice missions, now with simple scoring
    + Update RC Plane Challenge: Stats screen reworked and shows now several
      facts, simple ranking system based on used planes, some taunts in
      the game
    + New training/multiplayer mission: "Climb Home"
    + Game scheme screen has a "Script parameter" field now. This allows to
      make more customizable scripts/modes.
    + Network game rejoining. Note: Your team(s) will vanish after 3 turns.
    + Visual and gameplay changes to "sea" - world edge, visual change to wrap
      world edge to allow seeing through the wrap, visual change to bounce
      worldedge
    + The map of the Basketball Mission can be selected for regular games
      again ("BasketballField")
    + New engine command: /togglechat will disable/enable chat display (does
      not affect chat history display)
    + Change to Racer: first weapon/utility available will be automatically
      selected on start
    + Added some visual feedback to failed girder placement.
    + Various performance tweaks, especially for very large maps.
    + Allow switching through hogs in reverse order with
      PRECISE+HOGSWITCH (left shift + tab, by default)
    + Added support for custom Sudden Death music to theme.cfg
      (e.g. sd-music=hell.ogg ).
    + New Hats: policegirl, fr_tomato, cratehider
    * Fixed drill rockets sometimes exploding on impact.
    * Fixed trainings broken due to indestructable targets/crates.
    * Fixes and tweaks for low qualily rendering.
    * Sinegun won't shoot through -solid- land anymore
    * Many bug fixes and tweaks.
    Frontend / Netgame:
    + High resolution previews!
    + Preview for dynamic maps generated by game style scripts
      (e.g. "ShoppaMap))!
    + Moved room status filter to top left of rooms list.
    Lua API:
    + New library: Params, makes parsing of script parameters easier
    + New library: TargetPractice, used to generate target practice missions
      (the newly added missions use it)
    + More helpful syntax error messages.
    + New hooks:
      onParameters(paramString) -- called when script parameters are
      configured. the parameter contains the parameter(s) as text string
      onPreviewInit() -- called during map preview initialization
      onGearWaterSkip(gearUid) -- called when a gear skims the water without
      drowning (when hitting it with high speed at low angle). By checking
      gearUid you can figure out which gear that was.
    + New functions:
      DismissTeam(teamname) -- removes a team from the game (note: if you used
      loc() on teamnames, don't forget to the translated teamname here too)
      GetGameFlag(gameflag) -- returns true/false
      PlaceSprite(x, y, sprite, frameIdx [, landFlag, ... ]) -- sprite
      refers to an id from the TSprite list
      SetWaterLine(waterline) -- moves water level to the specified
      y. the current value is in read-only global waterline
      SetNextWeapon() -- make current hedgehog switch to next weapon.
      e.g. use in trainings to preselect weapon
      SetWeapon(ammoType) -- decide which weapon the current hedgehog should
      equip
    + Map Drawing:
      -- to be used in onGameInit() -- first set MapGen to mgDrawn and then use
      the commands below
      AddPoint(x, y [, width [, erase] ]) -- takes x,y location, a width (means
      start of a new line) and erase (if line should erase, not draw)
      FlushPoints() -- makes sure that all the points/lines specified using the
      command above are actually applied to the map
    + New global enumerations:
      Mapgens: mgRandom, mgMaze, mgPerlin, mgDrawn
      TSprite values
      LandFlags: lfIndestructible, lfIce, lfBouncy
    + Changed functions:
      HogSay(gearUid, text, manner [, vgState]) -- now also allows you to make
      NON-Hedgehog gears speak, e.g. barrels... wait what?!
    + Changed hooks:
      onHogAttack() can now be hooked with new parameter:
      onHogAttack(ammoType) - to conveniently find out which ammo/weapon
      is being used
    * Fixes:
      gfResetHealth is now a available like the other GameFlags

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 26 Dec 2014 11:33:43 +0100

hedgewars (0.9.20.5+git20141210-2) experimental; urgency=medium

  * Add disable-fstack-protector.patch

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 10 Dec 2014 17:33:06 +0100

hedgewars (0.9.20.5+git20141210-1) experimental; urgency=medium

  * New upstream release snapshot.
  * Update copyright lua entry.
  * Drop all debian patches, merged upstream.
  * Use C engine where fpc is not available.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 10 Dec 2014 13:00:24 +0100

hedgewars (0.9.20.5-12) unstable; urgency=medium

  * Fix experimental lintian warnings (copyright)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Fri, 17 Oct 2014 18:00:32 +0200

hedgewars (0.9.20.5-11) unstable; urgency=medium

  * Bump std-version to 3.9.6, no changes required.

