=== debian/changelog ===
hedgewars (0.9.21.1-5build1) wily; urgency=medium

  * No-change rebuild against ffmpeg 2.7

 -- Rico Tzschichholz <ricotz@ubuntu.com>  Tue, 01 Sep 2015 18:54:05 +0200

hedgewars (0.9.21.1-5) unstable; urgency=medium

  * Add a debug package, per upstream request.
    - 0001-Add-RelWithDebInfo-for-debugging-purposes.patch
      Add RelWithDebInfo support for cmake.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Thu, 15 Jan 2015 16:08:17 +0100

hedgewars (0.9.21.1-4) unstable; urgency=medium

  * Fix some copyright issues.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 07 Jan 2015 17:29:07 +0100

hedgewars (0.9.21.1-3) unstable; urgency=medium

  * Upload to unstable, with no patches at all.
    - the clang build failure seems probably clang-related (cfr: #754417).
      leaving the arch enabled until some clang folk fixes this.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 07 Jan 2015 11:02:36 +0100

hedgewars (0.9.21.1-2) experimental; urgency=medium

  * Try to not use fstack-protector when BUILD_ENGINE_C, clang is
    failing to build on arch != arm64.

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Wed, 07 Jan 2015 06:55:03 +0100

hedgewars (0.9.21.1-1) unstable; urgency=medium

  * New upstream bugfix release.
    - Drop every debian patch, all merged upstream.
  [ Reiner Herrmann ]
  * Make hedgewars create reproducible builds, by removing timestamp
    on build-time created png icons. (Closes: #774633)

 -- Gianfranco Costamagna <costamagnagianfranco@yahoo.it>  Mon, 05 Jan 2015 16:57:51 +0100
