=== debian/control ===
--- 
+++ 
@@ -30,7 +30,6 @@
                libghc-zlib-dev,
                libglew-dev [arm64 hurd-i386 kfreebsd-amd64 kfreebsd-i386 mips mipsel ppc64el s390x alpha hppa m68k powerpcspe sh4 x32],
                liblua5.1-dev,
-# new dependency
                libphysfs-dev,
                libpng-dev,
                libqt4-dev,
@@ -89,3 +88,12 @@
  This package contains data files for the hedgewars package.
  Examples of files are: maps, scripts, themes, images, sounds,
  level data and other miscellaneous files needed by hedgewars.
+
+Package: hedgewars-dbg
+Section: debug
+Architecture: any
+Depends: hedgewars (= ${binary:Version}),
+         ${misc:Depends},
+         ${shlibs:Depends}
+Description: Debug symbols for Hedgewars
+ This package contains debug symbols for the hedgewars package.
