=== debian/rules ===
--- 
+++ 
@@ -14,7 +14,7 @@
 HEDGEWARS_OPTIONS= \
  -DCMAKE_INSTALL_PREFIX=/usr/lib/hedgewars \
  -DDATA_INSTALL_DIR=/usr/share/games/hedgewars \
- -DCMAKE_BUILD_TYPE=RELEASE -DPHYSFS_SYSTEM=ON \
+ -DCMAKE_BUILD_TYPE=RelWithDebInfo -DPHYSFS_SYSTEM=ON \
  -DFONTS_DIRS='/usr/share/fonts/truetype/wqy;$(DEJAVU_DIRECTORY)' \
  -DNOVERSIONINFOUPDATE=1 \
  -DBUILD_ENGINE_C=$(BUILD_ENGINE_C)
@@ -35,6 +35,9 @@
 		dirname=`basename $$dirname`; \
 		basename=`basename $$icon .xpm`; \
 		mkdir -p tmp-icon/$$dirname/apps; \
-		convert $$icon tmp-icon/$$dirname/apps/$$basename.png; \
+		convert $$icon +set date:create +set date:modify -define png:exclude-chunk=time tmp-icon/$$dirname/apps/$$basename.png; \
 	done
 	dh_auto_configure -- $(HEDGEWARS_OPTIONS)
+
+override_dh_strip:
+	dh_strip --dbg-package=hedgewars-dbg
